" txtbrowser.vim:	Utilities to browser plain text file.
" Release:		1.3.6
" Maintainer:		ypguo<guoyoooping@163.com>
" Last modified:	2018.09.11
" License:		GPL

" Line continuation used here
let s:cpo_save = &cpo
set cpo&vim

scriptencoding utf-8

" ****************** Options *******************************************
"How many title level to support, default is 3.
if !exists('TxtBrowser_Title_Level')
	let TxtBrowser_Title_Level = 3
endif

"When this file reload, only load TBrowser_Ctags_Cmd once.

if !exists('Tlist_Ctags_Cmd')
	echomsg 'TxtBrowser: Taglist(http://www.vim.org/scripts/script.php?script_id=273) ' .
				\ 'not found. Plugin is not loaded.'
	" Skip loading the plugin
	let loaded_taglist = 'no'
	let &cpo = s:cpo_save
	finish
endif

if !exists('TBrowser_Ctags_Cmd')
	let TBrowser_Ctags_Cmd = Tlist_Ctags_Cmd
endif

"Rst tag definition start.
let s:TBrowser_Config = ' --langdef=rst --langmap=rst:.rst '

"Title tag definition
"let s:TBrowser_Config .= '--regex-rst=''/^([0-9]+\.?[ \t]+)(.+$)/\1\2/c,content/'' '
"let s:TBrowser_Config .= '--mline-regex-rst="/(^.*)([[:space:]])*(^[=-]+)$/\1\3/c,content/{mgroup=2}" '
let s:TBrowser_Config .= '--mline-regex-rst="/^(.*)([[:space:]])*^(=+)$/\1/c,content/{mgroup=2}" '
let s:TBrowser_Config .= '--mline-regex-rst="/^(.*)([[:space:]])*^(-+)$/. \1/c,content/{mgroup=2}" '
let s:TBrowser_Config .= '--mline-regex-rst="/^(.*)([[:space:]])*^([+_~^]+)$/.   \1/c,content/{mgroup=2}" '

"Figure tag definition
"let s:TBrowser_Config .= '--regex-rst=''/^[ \t]+(figure[ \t]+[0-9a-zA-Z]+([.: ]([ \t]*.+)?)?$)/\1/f,figures/i'' '
"let s:TBrowser_Config .= '--regex-rst=''/^.. (.+)::[ \t]+(.+)$/\1: \2/d,directives/i'' '

"Pass parameters to taglist
let tlist_rst_settings = 'rst;c:content;t:tables'
let Tlist_Ctags_Cmd = TBrowser_Ctags_Cmd . s:TBrowser_Config

setlocal nu formatoptions=t2crmB shiftwidth=4 textwidth=78 keywordprg=clear;sdcv\ -n
"setlocal foldenable foldminlines=3 foldmethod=expr foldlevel=0 foldexpr=(getline(v:lnum)=~'^\\s*\|.*$')?1:0
setlocal foldenable foldminlines=3 foldmethod=expr foldlevel=999 foldexpr=(getline(v:lnum)=~'^[\|].*$')?1:0
set statusline=%=%F%m%r%h%w\ [ff=%{&ff}]\ [ft=%Y]\ [enc=%{&enc}]\ [fenc=%{&fenc}]\ %l,%v\ %p%%

" restore 'cpo'
let &cpo = s:cpo_save
unlet s:cpo_save

